import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";

/**
 * 省市区级联组件
 */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { Row, Col, Cascader, Input } from 'antd';
import { getCityTreeData } from '../../../common/tool';
import RULE from '../../../enums/rule'; // 封装组件

var AddressSelect = /*#__PURE__*/function (_Component) {
  _inherits(AddressSelect, _Component);

  var _super = _createSuper(AddressSelect);

  function AddressSelect(props) {
    var _this;

    _classCallCheck(this, AddressSelect);

    _this = _super.call(this, props);
    _this.selectChange = _this.selectChange.bind(_assertThisInitialized(_this));
    _this.inputChange = _this.inputChange.bind(_assertThisInitialized(_this));
    _this.state = {
      options: [],
      level: props.level || 3,
      selectValue: props.value.slice(0, 3),
      initValue: props.value.slice(3)
    };
    return _this;
  } // 组件载入时


  _createClass(AddressSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var level = this.state.level;
      var data = getCityTreeData(level);
      this.setState({
        options: data
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          options = _this$state.options,
          level = _this$state.level,
          initValue = _this$state.initValue,
          selectValue = _this$state.selectValue;
      var input = initValue.join();
      var inputLength = input.length;
      var disabled = this.props.disabled;
      return /*#__PURE__*/React.createElement("div", null, level === 4 ? /*#__PURE__*/React.createElement(Row, {
        gutter: 8
      }, /*#__PURE__*/React.createElement(Col, {
        span: 12
      }, /*#__PURE__*/React.createElement(Cascader, {
        disabled: disabled,
        defaultValue: selectValue,
        options: options,
        onChange: this.selectChange,
        placeholder: "\u8BF7\u9009\u62E9"
      })), /*#__PURE__*/React.createElement(Col, {
        span: 12
      }, /*#__PURE__*/React.createElement(Input, {
        disabled: disabled,
        defaultValue: input,
        maxLength: RULE.addressLength,
        onChange: this.inputChange,
        suffix: "".concat(inputLength, "/").concat(RULE.addressLength)
      }))) : /*#__PURE__*/React.createElement(Cascader, {
        disabled: disabled,
        defaultValue: selectValue,
        options: options,
        onChange: this.selectChange,
        placeholder: "\u8BF7\u9009\u62E9"
      }));
    }
  }, {
    key: "selectChange",
    value: function selectChange(data) {
      var onChange = this.props.onChange;
      var initValue = this.state.initValue;
      this.setState({
        selectValue: data
      });
      onChange(data.concat(initValue));
    }
  }, {
    key: "inputChange",
    value: function inputChange(event) {
      var onChange = this.props.onChange;
      var selectValue = this.state.selectValue;
      var inputValue = event.target.value;
      var data = inputValue ? [inputValue] : [];
      this.setState({
        initValue: data
      });
      onChange(selectValue.concat(data));
    }
  }]);

  return AddressSelect;
}(Component);

AddressSelect.propTypes = {
  level: PropTypes.number,
  value: PropTypes.array,
  disabled: PropTypes.bool,
  onChange: PropTypes.func
};
export default AddressSelect;