/**
 * 选择关联标签
 */
import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import { Tag } from 'antd'; // 封装组件

var SelectTag = /*#__PURE__*/forwardRef(function (props, ref) {
  var handleRemove = function handleRemove(e, itemVal) {
    var value = props.value,
        onChange = props.onChange;
    e.preventDefault();
    onChange(value.filter(function (item) {
      return item.value !== itemVal;
    }));
  };

  var value = props.value;
  if (!value) return null;
  return /*#__PURE__*/React.createElement("div", {
    ref: ref
  }, value.map(function (item, index) {
    return /*#__PURE__*/React.createElement(Tag, {
      closable: true,
      key: index,
      onClose: function onClose(e) {
        return handleRemove(e, item.value);
      }
    }, item.text);
  }));
});
SelectTag.propTypes = {
  value: PropTypes.array,
  onChange: PropTypes.func
};
export default SelectTag;